import type ESTree from "estree";
import type { Context } from "../../context";
export declare function convertESNode<N extends ESTree.Node>(node: null | undefined, parent: any, ctx: Context): null;
export declare function convertESNode<N extends ESTree.Node>(node: N, parent: any, ctx: Context): N;
export declare function convertESNode<N extends ESTree.Node>(node: N | null | undefined, parent: any, ctx: Context): N | null;
/** Analyze expression scope */
export declare function analyzeExpressionScope(node: ESTree.Expression, ctx: Context): void;
/** Analyze pattern scope */
export declare function analyzePatternScope(node: ESTree.Pattern, ctx: Context): void;
export declare function getWithLoc<N extends ESTree.Comment>(node: N): N & {
    start: number;
    end: number;
};
export declare function getWithLoc<N extends ESTree.Node>(node: N): N & {
    start: number;
    end: number;
};
export declare function getWithLoc<N extends ESTree.Node>(node: N | null | undefined): (N & {
    start: number;
    end: number;
}) | null | undefined;
